import{resolve as t,join as e,dirname as n}from"path";import{parse as s}from"node-html-parser";import*as i from"fs";import{promisify as l}from"util";import{request as r}from"https";import{globalAgent as a}from"http";const o=l(i.readdir);l(i.writeFile);const u=l(i.readFile),c=l(i.lstat);const h=function(t,e){let[n,...s]=e.querySelectorAll("head>title");t.assert("title.exists",null!=n,"A title tag must exist"),t.assert("title.single",0===s.length,"Must have only one title tag");let i=n.innerText;t.assert("title.content.html",i===n.innerHTML,"Must not include HTML content"),t.assert("title.content.undefined",-1===i.indexOf("undefined"),'Must not include "undefined" in `title` value'),t.assert("title.content.null",-1===i.indexOf("null"),'Must not include "null" in `title` value');let l=t.load("title.content.length");if(l){let e=i.length,n=!0===l?{}:l,{min:s,max:r}={min:10,max:300,...n};e<s?t.report("title.content.length",`Must not have less than ${s} characters`):e>r&&t.report("title.content.length",`Must not have more than ${r} characters`)}},d=function(t,e){let[n,...s]=e.querySelectorAll("link[rel=canonical]");t.assert("canonical.exists",null!=n,"A canonical link must exist"),t.assert("canonical.single",0===s.length,"Must have only one canonical link");let i=n.getAttribute("href")||"";t.assert("canonical.href.exists",i.length>0,"Must not have empty `href` target"),t.assert("canonical.href.absolute",/^https?:\/\//.test(i),"Must include a URL protocol in target"),t.assert("canonical.href.lowercase",!/[A-Z]/.test(i),"Must not include uppercase character(s)"),t.assert("canonical.href.https",/^https:\/\//.test(i),'Must point to an "https://" address');let{host:l}=t.options;t.assert("canonical.href.match",(t=>i.includes(t.hostname||l||"\0")),"Must include the provided `hostname` value")},f=function(t,e){let[n,...s]=e.querySelectorAll("meta[name=description]");t.assert("description.exists",null!=n,'A "meta[name=description]" must exist'),t.assert("description.single",0===s.length,"Must have only one description meta tag");let i=(n.getAttribute("content")||"").trim();t.assert("description.content.empty",i.length>0,"Must not be empty"),t.assert("description.content.html",!n.innerHTML,"Must not include HTML content"),t.assert("description.content.undefined",-1===i.indexOf("undefined"),'Must not include "undefined" in value'),t.assert("description.content.null",-1===i.indexOf("null"),'Must not include "null" in  value');let l=t.load("description.content.length");if(l){let e=i.length,n=!0===l?{}:l,{min:s,max:r}={min:10,max:300,...n};e<s?t.report("description.content.length",`Must not have less than ${s} characters`):e>r&&t.report("description.content.length",`Must not have more than ${r} characters`)}let r=e.querySelector("title");r&&t.assert("description.content.title",(()=>{let t=new Set(i.toLowerCase().split(/[^\w]+/g)),e=new Set(r.innerText.trim().toLowerCase().split(/[^\w]+/g));for(let n of e)if(t.has(n))return!0;return!1}),"Must include at least one word in the <title> tag.")},p=function(t,e){let[n,...s]=e.querySelectorAll("meta[name=viewport]");t.assert("viewport.exists",null!=n,'A "meta[name=viewport]" tag must exist'),t.assert("viewport.single",0===s.length,'Must have only one "viewport" meta tag');let i=n.getAttribute("content")||"";t.assert("viewport.content.empty",i.trim().length>0,'Must not have empty "content" value'),t.assert("viewport.content.device",i.includes("width=device-width"),'Must include "width=device-width" value'),t.assert("viewport.content.scale",i.includes("initial-scale=1"),'Must must include "initial-scale=1" value')},m=function(t,e){e.querySelectorAll("img").forEach((e=>{let n=e.getAttribute("alt")||"";t.assert("image.alt.exists",n.trim().length>0,"Must have an `alt` attribute"),t.assert("image.alt.content.undefined",-1===n.indexOf("undefined"),'Must not include "undefined" in `alt` value'),t.assert("image.alt.content.null",-1===n.indexOf("null"),'Must not include "null" in `alt` value')}))},g=function(t,e){let n=0,s=new Set,i=e.querySelectorAll("a"),{host:l}=t.options;l||console.warn("! cannot run `link.internal` rules without a known `host` value"),i.forEach((e=>{let i=e.getAttribute("href")||"";if(t.assert("link.href.exists",e.hasAttribute("href"),"Must have an `href` attribute"),"#"===i)return;if(/^(mailto|javascript)[:]/.test(i))return;let r=i.indexOf("#");if(-1!==r&&(i=i.substring(0,r)),s.has(i))return;s.add(i),t.assert("link.href.empty",i.trim().length>0,"Must not have empty `href` target");let a=!0;if(l){let{hostname:t}=new URL(i,"http://x.com");a="x.com"!==t&&t!==l}if(a)n++;else if(t.assert("link.internal.nofollow","nofollow"!==e.getAttribute("rel"),"Internal links must not include `rel=nofollow`"),t.assert("link.internal.lowercase",!/[A-Z]/.test(i),"Internal links should not include uppercase"),t.assert("link.internal.trailing",/(\S+\.\w+){1,}$/.test(i)||i.endsWith("/"),"Internal links must end with a trailing slash"),t.assert("link.internal.pretty",!/\.html?$/i.test(i),'Internal links should not include ".html" suffix'),t.assert("link.internal.absolute",/^([/]{1,2}|https?:\/\/)/.test(i),"Must be an absolute URL format"),t.assert("link.internal.https","/"===i||/^https:\/\//.test(i)||/^\/[^/]+/.test(i),'Must include "https://" prefix'),"_blank"===e.getAttribute("target")){let n=e.getAttribute("rel")||"";t.assert("link.blank.noopener",n.includes("noopener"),'Must include "rel=noopener" when "target=_blank" in use'),t.assert("link.blank.noreferrer",n.includes("noreferrer"),'Must include "rel=noreferrer" when "target=_blank" in use')}})),n&&t.assert("link.external.limit",(t=>n<=(t.max||50)),"Exceeded external links maximum")},w=["seolint.config.mjs","seolint.config.cjs","seolint.config.js"];async function v(s,i){let l=0,r=t(s,i),a=new Set(await o(r));for(;l<w.length;l++)if(a.has(w[l]))return e(r,w[l]);if(r=n(r),r.startsWith(s))return v(s,r)}function x(t,e){(e.presets||[]).forEach((e=>x(t,e))),e.plugins&&t.plugins.push(...e.plugins),e.rules&&Object.assign(t.rules,e.rules),t.inputs=e.inputs||t.inputs,t.host=e.host||t.host}async function M(t){let e={host:"",inputs:[],plugins:[],rules:{}},n=await v(t,".");if(n){let t=await Function("x",'return import("file:///"+x)')(n);x(e,t.default||t)}return e.plugins.unshift(h,d,f,p,m,g),e}class y extends Error{constructor(t,e){super(t),this.rule=e}}async function k(e={}){e.cwd=t(e.cwd||".");let n=await M(e.cwd)||{};if(e.host&&(n.host=e.host),e.input&&(n.inputs=e.input),n.host&&!/^https?:\/\//.test(n.host))throw new Error('A `host` value must include "http://" or "https://" protocol');return n}async function b(t,e){let{plugins:n=[],rules:i={},...l}=e||{},r=s(t),a={},o=!1,u={get options(){return l},load(t){let e=i[t];return null==e||e},report(t,e){throw new y(e,t)},assert(t,e,n){let s=u.load(t);if(!0===s)s={};else if(!s)return;("function"==typeof e?e(s):e)||u.report(t,n)}};for(let t of n)try{await t(u,r)}catch(t){t instanceof y?(a[t.rule]={message:t.message},o=!0):console.error("ERROR",t.stack)}if(o)return a}async function A(t,n){let s={};if((await c(t)).isFile()){if(!/\.html?$/.test(t))return s;return b(await u(t,"utf8"),n).then((e=>(e&&(s[t]=e),s)))}let i=await o(t);return await Promise.all(i.map((i=>A(e(t,i),n).then((t=>{Object.assign(s,t)}))))),s}async function O(t,e){let n={},s=await function(t){return new Promise(((e,n)=>{let s="",i=/^http:\/\//.test(t)&&a,l=r(t,{agent:i},(t=>{if(!(t.headers["content-type"]||"").includes("text/html"))return n('Invalid "Content-Type" header');t.setEncoding("utf8"),t.on("data",(t=>{s+=t})),t.on("end",(()=>e(s)))}));l.on("error",n),l.end()}))}(t);if(!e||!e.host){let n=new URL(t).origin;e={...e,host:n}}let i=await b(s,e);return i&&(n[t]=i),n}async function S(n,s){let i=0,l=/^https?:\/\//,r=t(s&&s.cwd||"."),a=0,o=[].concat(n&&n.inputs||[]);if(o.length===a)throw new Error("Missing inputs to analyze");for(;a<o.length;a++)l.test(o[a])?i++:o[a]=e(r,o[a]);if(i&&i!==o.length)throw new Error("Inputs cannot contain both file-system and URL targets");let u={},c=i?O:A;return await Promise.all(o.map((t=>c(t,n).then((t=>{Object.assign(u,t)})).catch((e=>{console.error("ERROR",t,e.stack||e)}))))),u}export{y as Assertion,k as config,A as fs,b as lint,S as run,O as url};
